// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIGridLayout;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
 Renders a grid-layout. The grid is defined by the columns and rows attributes. You can adjust the
  widths of the columns and rows by value of the tokens. The number of tokens describe the number of
  columns and rows.
  <pre>
  columns/rows ::= LAYOUT
  LAYOUT       ::= TOKEN [" " TOKEN]+
  TOKEN        ::= "auto" | MEASURE | FRACTION
  MEASURE      ::= [NUMBER] ("px" | "em" | "ex" | "rem" | ...)
  FRACTION     ::= [POSITIVE_INTEGER] "fr"
  </pre>
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.GridLayoutTagDeclaration}.
 */
@Generated("component.stg")
public class UIGridLayout
    extends AbstractUIGridLayout implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.gridLayout;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.GridLayout";


  enum PropertyKeys {
    columnSpacing,
    markup,
    columns,
    customClass,
    rowSpacing,
    rows,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Spacing between the columns in the actual layout.

  */
  public org.apache.myfaces.tobago.layout.Measure getColumnSpacing() {
    Object object = getStateHelper().eval(PropertyKeys.columnSpacing);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return Measure.ZERO;
  }

  public void setColumnSpacing(org.apache.myfaces.tobago.layout.Measure columnSpacing) {
    getStateHelper().put(PropertyKeys.columnSpacing, columnSpacing);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  <p>
   This value defines the layout constraints for column layout.
   It is a space separated list of layout tokens '&lt;n&gt;fr', '&lt;measure&gt;' or the keyword 'auto'.
   Where &lt;n&gt; is a positive integer and &lt;measure&gt; is a valid CSS length.
   Example: '2fr 1fr 100px 3rem auto'.
   </p>
   <p>
   Deprecated: The old syntax for "2fr" is "2*". The old name for "auto" is "fixed".
   </p>
  <br>Default: <code>1fr</code>
  */
  public java.lang.String getColumns() {
    java.lang.String columns = (java.lang.String) getStateHelper().eval(PropertyKeys.columns);
    if (columns != null) {
      return columns;
    }
    return "1fr";
  }

  public void setColumns(java.lang.String columns) {
    getStateHelper().put(PropertyKeys.columns, columns);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Spacing between the rows in the actual layout.

  */
  public org.apache.myfaces.tobago.layout.Measure getRowSpacing() {
    Object object = getStateHelper().eval(PropertyKeys.rowSpacing);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return Measure.ZERO;
  }

  public void setRowSpacing(org.apache.myfaces.tobago.layout.Measure rowSpacing) {
    getStateHelper().put(PropertyKeys.rowSpacing, rowSpacing);
  }

  /**
  <p>
   This value defines the layout constraints for row layout.
   It is a space separated list of layout tokens '&lt;n&gt;fr', '&lt;measure&gt;' or the keyword 'auto'.
   Where &lt;n&gt; is a positive integer and &lt;measure&gt; is a valid CSS length.
   Example: '2fr 1fr 100px 3rem auto'.
   </p>
   <p>
   Deprecated: The old syntax for "2fr" is "2*". The old name for "auto" is "fixed".
   </p>
  <br>Default: <code>1fr</code>
  */
  public java.lang.String getRows() {
    java.lang.String rows = (java.lang.String) getStateHelper().eval(PropertyKeys.rows);
    if (rows != null) {
      return rows;
    }
    return "1fr";
  }

  public void setRows(java.lang.String rows) {
    getStateHelper().put(PropertyKeys.rows, rows);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}